(***********************************************************************)
(*                                                                     *)
(*                             Pio (OCaml)                             *)
(*                                                                     *)
(*                    Polyglot Input/Output Library                    *)
(*                                                                     *)
(*               EPI Pomdapi, INRIA Paris - Rocquencourt               *)
(*                                                                     *)
(*  Copyright 2005-2014 INRIA.                                         *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* $Id: gen_typed_values.ml,v 1.9 2014/03/04 18:54:30 fclement Exp $ *)

open Typed_value;;

let rec add_index i = function
  | [] -> []
  | t :: l -> of_int i :: t :: add_index (succ i) l
;;

let list =
  add_index 0
    [
     Typed_value.of_string "Hello Master Foo!";
     Typed_value.of_bool true;
     Typed_value.of_bool_couple (true, false);
     Typed_value.of_bool_triple (true, false, true);
     Typed_value.of_int 42;
     Typed_value.of_int_couple (4, 2);
     Typed_value.of_int_triple (4, -2, 1);
     Typed_value.of_float 42.0;
     Typed_value.of_float_couple (4.0, 2.0);
     Typed_value.of_float_triple (4.0, -2.0, 1.0);
     Typed_value.of_bool_vector [| true; true; |];
     Typed_value.of_bool_couple_vector [| (true, true); |];
     Typed_value.of_bool_triple_vector [| (true, false, true); |];
     Typed_value.of_string_vector [|"Hello"; " Master"; " Foo!"|];
     Typed_value.of_string_vector
       [|"que"; "j"; "aime"; ""; "faire"; "connatre";
         "ce"; "nombre"; "utile"; "aux"; "sages";|];
     Typed_value.of_int_vector [|4; 3; -2; 1; 0|];
     Typed_value.of_int_couple_vector [|4, 3; 3, -2; -2, 1; 1, 0|];
     Typed_value.of_int_triple_vector [|4, 3, 2; 3, -2, 1; 2, 1, 0|];
     Typed_value.of_float_vector [|4.3; 3.2; -2.1; 1.0|];
     Typed_value.of_float_couple_vector [||];
     Typed_value.of_float_triple_vector
       [|(34.0, 32.0, 31.0); (24.0, -22.0, 21.0); (14.0, 12.0, 11.0)|];
     Typed_value.of_c_int_matrix
       (Umatrix.of_array_array [|[|4; -3|]; [|-2; 1|]|]);
     Typed_value.of_fortran_int_matrix
       (Umatrix.of_array_array [|[|4; -3|]; [|-2; 1|]|]);
     Typed_value.of_c_float_matrix
       (Umatrix.of_array_array [|[|4.3; -3.2|]; [|-2.1; 1.0|]|]);
     Typed_value.of_fortran_float_matrix
       (Umatrix.of_array_array [|[|4.3; -3.2|]; [|-2.1; 1.0|]|]);
     Typed_value.of_string "Bye Master Foo!";
    ]
;;
